/*
 * ʸμΩ(Ƭޤ)³
 * 졢ưʤɤ°Υѥ򤿤ɤ롣
 * ѥϥդȤեѰդ롣
 *
 *
 *  +------+
 *  |      |
 *  |branch+--cond--+--transition--> node
 *  |      |        +--transition--> node
 *  | NODE |
 *  |      |
 *  |branch+--cond-----transition--> node
 *  |      |
 *  |branch+--cond-----transition--> node
 *  |      |
 *  +------+
 *
 * Copyright (C) 2000-2003 TABATA Yusuke
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <conf.h>
#include <ruleparser.h>
#include <xstr.h>
#include <logger.h>
#include <segclass.h>
#include <splitter.h>
#include <wtype.h>
#include "wordborder.h"

static int nrNodes;

#define WEAK_CONNECTION 8
#define WEAKER_CONNECTION 2
#define NORMAL_CONNECTION 1

struct dep_transition {
  /** ΥΡɤֹ 0ξϽü */
  int next_node;
  /** ܤΥ */
  int trans_ratio;
  /** ѷ */
  int ct;
  /** ʻ */
  int pos;
  /** */
  int strong;
};

struct dep_branch {
  /* ܾ° */
  /** Ĺ */
  int nr_strs;
  /** ܾ */
  xstr *str;
  
  /** ΥΡ */
  int nr_transitions;
  struct dep_transition *transition;
};

static struct dep_node {
  /** Ρɤ̾ */
  char *name;

  int nr_branch;
  struct dep_branch *branch;
}*gNodes;

static void
match_branch(struct splitter_context *sc,
	     struct word_list *tmpl,
	     xstr *xs, struct dep_branch *db);
static void
match_nodes(struct splitter_context *sc,
	    struct word_list *wl,
	    xstr follow_str, int node);

/* ʸˡե˶ΥΡɤ뤫å */
static void
check_nodes(void)
{
  int i;
  for (i = 1; i < nrNodes; i++) {
    if (gNodes[i].nr_branch == 0) {
      anthy_log(0, "node %s has no branch.\n", gNodes[i].name);
    }
  }
}


/*
 * ƥΡɤˤܾƥȤ
 *
 * wl Ωword_list
 * follow_str Ωʹߤʸ
 * node 롼ֹ
 */
static void
match_nodes(struct splitter_context *sc,
	    struct word_list *wl,
	    xstr follow_str, int node)
{
  struct dep_node *dn = &gNodes[node];
  struct dep_branch *db;
  int i,j;

  /* ƥ롼 */
  for (i = 0; i < dn->nr_branch; i++) {
    db = &dn->branch[i];
    /* ܾ */
    for (j = 0; j < db->nr_strs; j++) {
      xstr cond_xs;
      /* °ܾĹȤɬ */
      if (follow_str.len < db->str[j].len){
	continue;
      }
      /* ܾʬڤФ */
      cond_xs.str = follow_str.str;
      cond_xs.len = db->str[j].len;
      /* ܾӤ */
      if (!anthy_xstrcmp(&cond_xs, &db->str[j])) {
	/* ܾmatch */
	struct word_list new_wl = *wl;
	struct part_info *part = &new_wl.part[PART_DEPWORD];
	xstr new_follow;

	part->len += cond_xs.len;
	new_follow.str = &follow_str.str[cond_xs.len];
	new_follow.len = follow_str.len - cond_xs.len;
	/* θ */
	if (cond_xs.len) {
	  part->ratio *= 15;
	  part->ratio /= 16;
	}
	if (part->ratio == 0) {
	  part->ratio = 1;
	}
	/* ܤƤߤ */
	match_branch(sc, &new_wl, &new_follow, db);
      }
    }
  }
}

/*
 * ܤ¹ԤƤߤ
 *
 * tmpl ޤǤ˹word_list
 * xs Ĥʸ
 * db Ĵbranch
 */
static void
match_branch(struct splitter_context *sc,
	     struct word_list *tmpl,
	     xstr *xs, struct dep_branch *db)
{
  struct part_info *part = &tmpl->part[PART_DEPWORD];
  int i;
  /* ˥ȥ饤 */
  for (i = 0; i < db->nr_transitions; i++) {
    /* score¸ */
    int conn_ratio = part->ratio;

    struct dep_transition *transition = &db->transition[i];

    /* ܤΥ */
    part->ratio *= transition->trans_ratio;
    part->ratio /= RATIO_BASE;
    /* ܤγѷʻ */
    part->pos = transition->pos;
    part->ct = transition->ct;

    /* ܤü */
    if (transition->next_node) {
      /*  */
      match_nodes(sc, tmpl, *xs, transition->next_node);
    } else {
      struct word_list *wl;
      /* 
       * üΡɤãΤǡ
       * word_listȤƥߥå
       */
      wl = anthy_alloc_word_list(sc);
      *wl = *tmpl;
      wl->len += part->len;
      /* ³ */
      if (part->len == 1 && transition->strong) {
	wl->part[PART_DEPWORD].ratio *= 3;
	wl->part[PART_DEPWORD].ratio /= 2;
      }
      /**/
      anthy_commit_word_list(sc, wl);
    }
    part->ratio = conn_ratio;
  }
}

/** 
 */
void
anthy_scan_node(struct splitter_context *sc,
		struct word_list *tmpl,
		xstr *follow, int node)
{
  /* °դƤʤ֤鸡򳫻Ϥ */
  match_nodes(sc, tmpl, *follow, node);
}

int
anthy_get_node_id_by_name(const char *name)
{
  int i;
  /* ϿѤߤΤΤõ */
  for (i = 0; i < nrNodes; i++) {
    if (!strcmp(name,gNodes[i].name)) {
      return i;
    }
  }
  /* ʤäΤǺ */
  gNodes = realloc(gNodes, sizeof(struct dep_node)*(nrNodes+1));
  gNodes[nrNodes].name = strdup(name);
  gNodes[nrNodes].nr_branch = 0;
  gNodes[nrNodes].branch = 0;
  nrNodes++;
  return nrNodes-1;
}

/*
 * ܤparse
 * ܤ [:.ZYSTKMGv]@(Ρ̾)
 */
static void
parse_transition(char *token, struct dep_transition *tr)
{
  int conn = NORMAL_CONNECTION;
  int ct = CT_NONE;
  int pos = POS_NONE;
  int strong = 0;
  /* ܤ° */
  while (*token != '@') {
    switch(*token){
    case ':':
      conn = WEAKER_CONNECTION;
      break;
    case '.':
      conn = WEAK_CONNECTION;
      break;
    case 'Z': ct = CT_MIZEN; break;
    case 'Y': ct = CT_RENYOU; break;
    case 'S': ct = CT_SYUSI; break;
    case 'T': ct = CT_RENTAI; break;
    case 'K': ct = CT_KATEI; break;
    case 'M': ct = CT_MEIREI; break;
    case 'G': ct = CT_HEAD; break;
    case 'v': pos = POS_V; break;
    case '*': strong = 1; break;
    default:
      break;
    }
    token ++;
  }
  /* @ϥΡɤ̾ */
  tr->next_node = anthy_get_node_id_by_name(token);
  /* ³ζ */
  tr->trans_ratio = RATIO_BASE / conn;
  /**/
  tr->ct = ct;
  tr->pos = pos;
  tr->strong = strong;
}

/*
 * Ρ̾ ܾ+ +
 */
static void
parse_line(char **tokens, int nr)
{
  int id, row = 0;
  struct dep_branch *db;
  struct dep_node *dn;

  /* ΡɤȤid */
  id = anthy_get_node_id_by_name(tokens[row]);
  dn = &gNodes[id];
  row ++;

  /* ΥΡɤ˥֥ɲä */
  dn->branch = realloc(dn->branch,sizeof(struct dep_branch)*(dn->nr_branch+1));
  db = &dn->branch[dn->nr_branch];
  dn->nr_branch++;
  db->nr_strs = 0;
  db->str = 0;
  db->nr_transitions = 0;
  db->transition = 0;

  /* Υ֥ܾ°ΥꥹȤɲä */
  for (; row < nr && tokens[row][0] == '\"'; row++) {
    char *s;
    xstr *xs;
    s = strdup(&tokens[row][1]);
    s[strlen(s)-1] =0;
    xs = anthy_cstr_to_xstr(s);
    db->str = realloc(db->str, sizeof(xstr)*(db->nr_strs+1));
    db->str[db->nr_strs] = *xs;
    db->nr_strs ++;
    free(s);
    free(xs);
  }

  /* ܾ郎ʤϷٹФơܾɲä */
  if (db->nr_strs == 0) {
    char *s;
    xstr *xs;
    anthy_log(0, "node %s has a branch without any transition condition.\n",
	      tokens[0]);
    s = strdup("");
    xs = anthy_cstr_to_xstr(s);
    db->str = malloc(sizeof(xstr));
    db->str[0] = *xs;
    db->nr_strs = 1;
    free(s);
    free(xs);
  }

  /* ΥΡɤɲä */
  for ( ; row < nr; row++){
    db->transition = realloc(db->transition,
			     sizeof(struct dep_transition)*
			     (db->nr_transitions+1));
    parse_transition(tokens[row], &db->transition[db->nr_transitions]);
    db->nr_transitions ++;
  }
}

int
anthy_init_depword_tab()
{
  const char *fn;
  char **tokens;
  int nr;

  /* id 0 Ρɤ˳Ƥ */
  anthy_get_node_id_by_name("@");

  fn = anthy_conf_get_str("DEPWORD");
  if (!fn) {
    anthy_log(0, "Dependent word dictionary is unspecified.\n");
    return -1;
  }
  if (anthy_open_file(fn) == -1) {
    anthy_log(0, "Failed to open dep word dict (%s).\n", fn);
    return -1;
  }
  while (!anthy_read_line(&tokens, &nr)) {
    parse_line(tokens, nr);
    anthy_free_line();
  }
  anthy_close_file();
  check_nodes();
  return 0;
}

void
anthy_release_depword_tab(void)
{
  int i, j, k;
  for (i = 0; i < nrNodes; i++) {
    free(gNodes[i].name);
    for (j = 0; j < gNodes[i].nr_branch; j++) {
      for (k = 0; k < gNodes[i].branch[j].nr_strs; k++) {
	free(gNodes[i].branch[j].str[k].str);
      }
      free(gNodes[i].branch[j].str);
      free(gNodes[i].branch[j].transition);
    }
    free(gNodes[i].branch);
  }
  free(gNodes);
  gNodes = 0;
}
